# Proxidize Android: Создать 5G/4G Mobile Proxy Farms для Андроида

Proxidize Android Legacy - это приложение для Android, которое позволяет любому создать мобильный прокси-сервер 5G или 4G с помощью своего телефона без необходимости дополнительного оборудования. Просто скачате приложение, нажмите "Подключиться" и Ваш мобильный прокси будет создан автоматически.

Proxidize создало Proxidize Android как доказательство концепции Proxidize MPM (Mobile Proxy Maker). Приложение достигло своей цели, но, в конечном итоге, было удалено из магазина Google Play по причинам, указанным ниже.

Proxidize Android Legacy - это преддшественник грядущего приложения Proxidize Portable, которое будет радикально улучшено в сравнение с текущим.

![Overview](https://i.imgur.com/gsRoRBt.png)

<div align="center"> </br><a href="https://github.com/proxidize/proxidize-android/releases/download/v2.1.0/proxidize-android-legacy-v2.1.0.apk">
    <img src="https://i.imgur.com/HkPj7Fx.png" height="auto"/>
  </a>
</br></br></br></div>

</div>


## Что такое Proxidize:

Proxidize - это многонациональная инициатива, начатая командой инженеров, для декмократизации доступа данных, а также автоматизации. Прочтите манифест Proxidize: https://proxidize.com/manifesto/


<div align="center"> <a href="https://proxidize.com/">
    <img src="https://i.imgur.com/3FEWrk5.png" height="auto"/>
  </a>
</div>

<div align="center">
  <h2>Proxidize</h2>
  <a href="#how-to-create-a-5g-or-4g-mobile-proxy-on-android-phones-turn-your-phone-into-a-mobile-proxy">Начните создание мобильного прокси-сервера Proxies</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="#rotationchanging-the-ip-how-to-change-mobile-proxy-android-ip-address-using-airplane-mode">ротация IP-адресов</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="https://proxidize.com/">Вебсайт</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="https://proxidize.com/android">Документация</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="https://proxidize.com/blog">Блог</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="https://twitter.com/proxidizehq">Твиттер</a>
  <span>&nbsp;&nbsp;•&nbsp;&nbsp;</span>
  <a href="#proxidize-portable">Proxidize Portable</a>
  <br />
  <hr />
</div>

---

## Особенности Proxidize Android Legacy

![image](https://user-images.githubusercontent.com/107770894/190168239-2084da54-9b5a-4ed6-9ab8-3bd21671adf5.png)


- Создание мобильного или резидентного прокси-сервера HTTP(S) или SOCKS5 на устройствах Android, MacOS или Windows
- Ротация/Изменение IP-адресов двумя способами: вручную с помощью кнопки и автоматически с ипользованием определенного интервала в ротации
- API Ротация/Изменение IP-адресов, которые можно использовать как ссылку/URL.
- Подключение к мобильным данным в момент использования приложения для создания мобильного прокси-сервера.
- Поключение к Wi-Fi в момент использования приложения для создания резидентного прокси-сервера
- Супер быстрая балансировка нагрузки, управляемая глобальными серверами.
- Добавление собственно настроенного туннельного сервера для больше безопасности и скорости.
- Экспериментально: Изменение ОС с помощию биометрики (отпечатка пальца) для улучшения безопасности.
- Экспериментально: Раздельное соединение к бэкэнду Wi-Fi для повышения скорости.   


---

## Как это работает и Архитектура

Proxidize Android Legacy работает, устанавливая соединение с туннельным сервером через обратные прокси-серверы, а затем запуская локальный прокси-сервер HTTP. Это делает прокси-сервер доступным из любой точки Интернета, поскольку туннельный сервер обрабатывает переадресацию и маршрутизацию портов.

<div align="center">
    <img src="https://i.imgur.com/9UAAcx3.png" height="auto"/>
</div>


Приложение выберет случайный порт между ```10000``` и ```60000```, использует его для подключения к клиенту, а затем создаст прокси-сервер на основе случайного порта вместе со случайно сгенерированным именем пользователя и пароля.


---

## Содержание

- [Proxidize Android - Создать 5G/4G мобильные прокси-серверы на устройствах Android](#proxidize-android-create-5g4g-mobile-proxy-farms-on-android-phones)
  * [Что такое Proxidize?](#what-is-proxidize)
  * [Особенности of Proxidize Android Legacy](#features-of-proxidize-android-legacy)
  * [Как это работает и Архитектура](#how-it-works-and-architecture)
  * [Proxidize Android Legacy против Proxidize Mobile Proxy Maker](#proxidize-android-legacy-vs-proxidize-mobile-proxy-maker)
  * [Как создать 5G/4G мобильный прокси-сервер на устройствах Android: (Превратите свой телефон в мобильный прокси-сервер)](#how-to-create-a-5g-or-4g-mobile-proxy-on-android-phones-turn-your-phone-into-a-mobile-proxy)
    + [Как использовать на Windows MacOS (Создать 5G или 4G мобильный прокси-сервер на WindowsMacOS)](#rotationchanging-the-ip-how-to-change-mobile-proxy-android-ip-address-using-airplane-mode)
  * [Использование прокси-сервера](#using-the-proxy)
  * [Ротация/Изменение IP-адреса (Как изменить Android IP-адрес мобильного прокси-сервера, используя Режим Самолета)](#rotation-changing-the-ip--how-to-change-mobile-proxy-android-ip-address-using-airplane-mode)
    + [Автоматическое изменение IP-адреса](#automatically-changing-the-ip-address)
    + [Изменение IP-адреса вручную](#changing-the-ip-manually)
    + [Изменение IP-адреса с помощью URL/API](#changing-the-ip-via-url-api)
  * [Поддерживаемые версии и устройства Android](#supported-android-versions--devices)
  * [Размещение Вашего собственного сервера Your Own Server](#deploying-your-own-server)
    + [Пример](#example)
  * [Использование приложения без первичного подключения к туннельному серверу](#using-the-app-without-connecting-to-the-tunneling-server-first)
  * [Сообщение о проблемах](#reporting-issues)
    + [Виды проблем, о которых следует сообщать](#types-of-issues-that-you-should-report)
    + [Как сообщить о проблеме](#how-to-report-the-issue)
    + [Любая проблема, несвязанная с приложением будет закрыта](#any-issues-unrelated-to-the-app-will-be-closed--such-as)
  * [Оновления](#updates)
  * [FAQ:](#faq)
    + [Почему данное приложение помечено как вредоносное ПО Google-ом?](#why-is-the-app-marked-as-harmful-appmalware-by-google)
    + [Мой прокси-сервер не работает с ```Прокси-сервер отказывается принимать соединения``` ошибка?](#my-proxy-isnt-working-with-proxy-refusing-connection-error)
    + [Мой прокси-сервер перстал работать, хотя до этого работал, можете мне помочь?](#my-proxy-stopped-working-after-it-used-to-work-can-you-help)
    + [Почему мой прокси-сервер такой медленный?](#why-is-my-proxy-slow)
    + [Где данное приложение будет работать?](#where-will-this-app-work)
    + [Я продолжаю получать ```407 Ошибка``` или прокси-сервер продолжает требовать авторизацию?](#i-keep-getting-a-407-error-or-the-proxy-keeps-asking-for-authentication)
  * [Proxidize Portable](#proxidize-portable)

 
 ---

## Proxidize Android Legacy против Proxidize Mobile Proxy Maker

Данное приложение не является заменой Proxidize Mobile Proxy Maker, но является доказательством концепции. Вы можете использовать это приложение в небольших масштабах для личных проектов, но как только Вам понадобится решение коммерческого характера, Вам поднадобится Proxidize MPM по следующим причинам:

- Такие приложения всегда будут ненадежными по объективным причинам из-за того, что базовая инфраструктура предназначена в большей мере для IoT устройста, а не для прокси-серверов.
- Низкая скорость.Поскольку и входящие, и исходящие соединения проходят через один и тот же сетевой интерфейс, скорость, которую Вы получите, будет составлять 1/5 часть скорости мобильного телефона.
- Трудно управлять в масштабе. Настройка комплекта из 20 модемов от Proxidize занимает 10 минут, но настройка 20 телефонов займёт целый день, если не больше.

---

## Как создать мобильный прокси-сервер 5G или 4G мобильный прокси-сервер на телефонах Android: (Превратите свой телефон в мобильный прокси-сервер)

<div align="center">
    <img src="https://i.imgur.com/ASSDAe2.png" height="auto"/>
</div>


- Скачайте Proxidize Android Legacy APK файл.
- Установите APK на Ваше устройство.
- Откройте приложение и нажмите "Подключиться".
- Скопируйте прокси-сервер и можете его использовать где угодно.

Итак, Вы создали свой собственный мобильный 5G/4G прокси-сервер!

### Как ипользовать на Windows MacOS (Создайте 5G или 4G мобильный прокси-сервер на WindowsMacOS)

- Скачайте любой Android эмулятор поо типу BlueStacks.
- Скачайте Proxidize Android Legacy APK файл внутри эмулятора (Откройте эту страницу из эмулятора и скачайте APK).
- Установите APK на Ваше устройство.
- Откройте приложение и нажмите "Подключиться".
- Скопируйте прокси-сервер и можете его использовать где угодно.

---

## Использование прокси-сервера

Формат;
```
IP:Порт:Пользователь:Пароль
```

Пример:
```
1.1.1.1:1565:abc:xyz
```

Результат:
```
IP or Hostanme: 1.1.1.1
Порт: 1565
Пльзователь: abc
Пароль: xyz
```
---
## Ротация.Изменение IP-адреса (Как изменить IP-адрес мобильного прокси-сервера на Android используя Режим Самолёта)

Proxidize Android Legacy имеет встроенную ротацию. Чтобы настроить её, Вам необходимо установить приложение в качестве помощника по умолчанию в настройках.


### Автоматическое изменение IP-адреса:

<div align="center">
    <img src="https://i.gyazo.com/8c923c64c2996452c78993003e023d94.png" height="auto"/>
</div>

Proxidize Android Legacy позволяет Вам устанавливать интервал для ротации/изменения IP-адреса. Для использования Вам необходимо:
- Нажмите "АВТОМАТИЧЕСКОЕ ИЗМЕНЕНИЕ IP" кнопку на домашней странице.
- Выберите интервал ротации, который Вы хотите использовать.
- Выберите время в минутах. Все что меньше 30 минут навредит Вашему телефону.
- Нажмите "УСТАНОВИТЬ" и Ваши настройки будут применены.



### Изменение IP-адреса вручную:

<div align="center">
    <img src="https://i.gyazo.com/ad6fa87d163262908253e99cf2f436ab.png" height="auto"/>
</div>


Чтобы изменить IP-адрес вручную, Вам лишь нужно нажать на "Изменить IP-адрес" кнопку.



### Изменение IP-адреса с помощью URL/API:

<div align="center">
    <img src="https://i.gyazo.com/ded5e4abaf6f19ca75ff5045889dced4.png" height="auto"/>
</div>

Proxidize Android Legacy генерирует IP-адрес ссылку/URL/API изменения, которую Вы можете использовать где угодно, чтобы изменить IP-адрес.

Чтобы изменить IP-адрес с помощью ссылки ротации, Вам нужно:
- Скопируйте IP-адрес ссылку/URL/API изменения под "IP-адрес Изменения ссылка/API" нажав кнопку "Копировать".
- Use the link anywhere or send a GET request to it.

Успешный ответ должен быть таким:

```{"ответ":"успешно"}```

---
## Поддерживаемые версии и устройства Android

Proxidize Android Legacy поддерживает все ```armeabi-v7a``` работающие от```Android 6.0``` до ```Android 12```

Поддерживаемые Android API от ```API 23``` до ```API 31```.

Протестированные устройства:

```
Все Android 6.0+ телефоны
Samsung A Series
Samsung S Series
Samsung M Series
Samsung Note Series
Google Pixel
OnePlus
```
---

## Размещение Вашего собственного сервера

<div align="center">
    <img src="https://i.gyazo.com/cc24b11d87379469f06ac8f15257dcbe.png" height="auto"/>
</div>

Proxidize Android Legacy позволяет Вам развернуть собственный туннельный сервер чтоб избежать использования общих/перегруженных серверов. Для этого Вам необходимо:
- Создайте новый сервер на любов хосте. Убедитесь, что Вы находитесь в общедоступной сети со всеми общедоступными портами.
- Отредактируйте файл конфигурации, чтобы добавить информацию о Вашем сервере.
- Отредактируйте ```ПОЛЬЗОВАТЕЛЬСКИЙ СЕРВЕР``` поля чтобы добавить новый сервер.

### Пример:

- IP-адрес сервера = ```5.5.5.5```

- Убедитесь, что сервер ```x86-64``` или ```AMD64``` работает ```Ubuntu 20.04```

- SSH на Ваш сервер

``` ssh username@5.5.5.5```

- Клонировать это репо

``` git clone https://github.com/proxidize/proxidize-android.git  ```

- Отредактируете server.ini file чтобы добавить токен аутентификации

``` vi``` or ```nano ./server.ini ```

- Добавить следующую информацию, заменяя ```ПОРТ``` и ```ТОКЕН``` Вашими значениями. Оставить по умолчанию значение порта ```2000``` если нет причин менять его.

```
[common]
bind_port = PORT
authentication_method=token
token = TOKEN
```

```TOKEN``` используется для аутентификации клиента, который может подключаться к этому серверу. Это может быть случный набор символов, таких как  ```12345678```.

- Запустите сервер

``` setsid ./server -c ./server.ini &```

```setsid``` используется для поддержания процесса после закрытия терминала.

- Добавьте информацию о новом сервере в Ваше приложение с помощью Меню > Изменить сервер > Пользовательский.

```HOST``` = Общедоступный IP-адрес нового сервера.В данном примере это ```5.5.5.5```.

```Binding Port``` = Выбранный порт.

```Token``` = Выбранный токен.

- Сохраните данные, выйдите из приложения, откройте его снова и нажмите "Подключиться". Теперь Вы подключитесь к своему новому туннельному серверу.


---
## Используя приложение без первичного подключения к туннельному серверу

В некоторых случаях, Вы можете подключиться напрямую к телефону без необходимости подключения к туннельному серверу. Преимущество этого в том, что Вам не нужно будет сначала подключаться к туннельному серверу, который предлагает на 5-10% более высокую скорость.

- Убедитесь, что Ваш провайдер может предоставить Вам выделенный v4 IP. Такое случается очень редко и Вам необходимо будет уточнить такую возможность у провайдера.
- Позвоните Вашему провайдеру и попросите выслать Вам порты.
- Получите Ваш общедоступный IP-адрес, выполнив "поиск моего IP-адреса".
- Приложение прослушивает 0.0.0.0 поэтому после перееадресации порта прокси просто подключитесь к нему, используя общедоступный IP-адрес.
- Вы также можете сделать это, если Вы поключены к Wi-Fi, но Вам нужно будет перенаправить порты на Вашем маршрутизаторе.


---

## Сообщить о проблеме

### Виды проблем, о которых нужно сообщить:

- Приложение постоянно зависает/вылетает на определенном устройстве/Android версии.
- Оптимизация обхода батареи не работаетна определенном устройстве/Android версии.
- Приложение через некоторое время перестало работать на любов устройстве/версии
- Прокси-сервер выдает ошибку соединения даже если порт и хост указан правильно.
- Если Вы видите следующие ошибка: 12020, 12033 или 12165.

### Как сообщать об ошибке:

- Полное описание ошибки, включая скриншоты и коды ошибки.
- Полное имя устройства, производитель, модель. Пример Samsung SM-A105L
- Добавьте скриншот о Версии ПО телефона
- Полная инструкции по вопроизведению ошибки.


### Любая ошибка, несвязанная с приложением будет закрыта, такая как:

- Я отправил 1,000 сообщении Amazon и теперь мой IP-адрес забанен.
- Я использую vanilla puppeteer или Chrome и меня блокируют или идентифицируют мой прокси.
- Дюбой тип ошибки 407/ошибка аутентификации. Это значит Вы вводите неправильные данные. Обратитесь в раздел форматирования.
- 502 or 504 if you're using rotation. This happens when you're connecting in the middle of a rotation.
- Любая ситуация, где Вы используете Ваш собственный сервер. (Кроме случая, если в сумели полность воспроизвести ошибку на обучных серверах.)


---
## Обновления:

Данное приложение больше не поддерживается Proxidize, но я (Абед) буду над этим работать в свое свободное время.

Редактирование: Я закончил почти все запланированные пункту раньше срока.Так что есть шанс что я не буду делать како-то времы обновления.

Вещи которые я добавлю:

- [x] Поддержка Android 12
- [x] Добавить блокировку пробуждения Android чтобы прокси оставался активным.
- [x] Пользовательский сервер из приложения.
- [x] Сохранять порты между сессиями.
- [x] Кнопка ротации IP-адресов в приложении.
- [x] Автоматическая ротация IP-адресов.
- [x] Ротация IP-адресов через API
- [x] Подержка большего числа устройств Asus, Alcatel, итд.
- [x] Автоматическое определение ближайшего сервера.
- [x] SOCKS прокси.
- [x] Предотвращать дублирования портов на сервере.
- [ ] Отображение общедоступного IP-адреса в интерфейсе приложения.
- [ ] Поменять рокси формат.

Если Вы обновляетесь на версию v2.0.0 с v1.0.0 убедитесь, что перед этим удалили v1.0.0.

---


## FAQ:

### Почему данное приложение помечено как вредоносное в Google маркете?

Через несколько месяцев после публикации приложения Google пометил его как вредоносное/PUP/вредоносное ПО. Я подозреваю, что это потому, что какой-то сторожевой таймер Google пронюхал трафик и обнаружил что-то вредоносное, что передавалось некоторыми пользователями. Или возможно, что поведение незашифрованного и перенаправленного на один сервер трафика было похоже на типичное поведение вредоносного приложения, которое встречается в Google в Play Store.

Есть также несколько AV, которые пометили прокси-сервер быстрого реверса туннелирующего клиента как ПНП, и, возможно, Google Play Store сделал то же самое.

Я предпринял некоторые меры против этого, изменив двоичные файлы для изменения хэша, но я подозреваю, что Google все равно пометит его как вредоносное, прочитав строки, поэтому вам нужно будет отключить Play Protect, иначе приложение, скорее всего, будет автоматически удалено. .

### Мой прокси не работает с ```Прокси не подключается``` ошибка?

Убедитесь, что вы используете правильное значение порта, затем выйдите из приложения и запустите его снова. Вероятность того, что вы использовали уже используемый порт, очень мала.

### Мой прокси перестал работать через какое-то время, можете мне помочь?

Закройте приложение и затем войдите вновь. Если все еще не работает, убедитесь что приложение запущено.Затем, пожалуйста, твитните [@Proxidizehq](https://twitter.com/proxidizehq) и я посмотрю в чем проблема.

### Почему мой прокси такой медленный?

Приложение использует обратные прокси-серверы, созданные через маршрут веб-сокетов, для пересылки прокси-серверов. Эта технология медленная, ненадежная, и я ничего не могу с этим поделать, учитывая то ограниченное время, которое у меня есть на работу над этим проектом. Приложения, основанные на этой конкретной технологии туннелирования, были созданы для простых случаев использования IoT, а не для использования полной полосы пропускания или прокси-серверов.

Команда Proxidize работает над совершенно новым приложением под названием **Proxidize Portable**, в котором будут устранены все недостатки этого приложения с использованием запатентованной технологии.

Другое дело, что такие приложения отправляют как входящий, так и исходящий трафик с одного и того же устройства, а это значит, что вы всегда будете получать половину скорости, которую обычно получаете при тестировании скорости прямо на телефоне. Если важна скорость, вам следует использовать полную версию Proxidize MPM-OP: https://proxidize.com/

### Где это приложение будет работать?

Приложение будет работать везде, кроме:
- Вы находитесь в стране, в которых ISP-уровень firewall который блокирует любые прокси подключения через DPI.
- У Вас включен корпоративный firewall который блокирует неизвестные порты.

### Я получаю ошибку ```407 Ошибка``` или прокси постоянно просит аутентификацию?

Убедитесь Вы не путаете маленькую ```l``` с большой ```I```.


---

## Proxidize Portable

На данный момент мы работаем на новым приложением, которое называется "Proxidize MPM-Cloud Portable" или сокращенное название "Proxidize Portable". Новое приложениеnew app will address all the deficiencies of this one and will have the following features:

1. В 5-10 раз выше скоростьчем Proxidize Android Legacy
2. Отпечаток пальца OS
3. Отправка/получение SMS через интерфейс/API
4. Управление всеми устройствами через вебинтерфейс
5. Управление неограниченным количеством телефонов путем группировки по категориям итд.
6. Использование любого сервера из десятков стран.
7. Пользовательский DNS
8. До 99.99% безотказной работы
9. IPV4/IPV6 поддержка двойного стека
10. Сбалансированная нагрузка между большим количеством телефонов
11. Настройка пулов ротации IP/балансировки нагрузки для нескольких телефонов.
12. И многое другое!


       
